using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Media;

namespace EveSkillNotify
{
    public partial class Main : Form
    {
        private SkillNotify skNotify = null;
        public Main(bool hidden, string workingDir)
        {
            this.Visible = hidden;

            InitializeComponent();

            skNotify = new SkillNotify(this,workingDir);
        }
        public void LoadSettings(
            string EveUserID, string EveApiKey, bool NotifyWhenNoSkill, 
            bool NotifyWhenFinishedSkill, bool NotifyWhenUnder5Mins,
            bool NotifyWhenUnder1Hour, int CheckInterval, bool ShowStatusOnTrayClick,
            bool StartWithWindows, bool ForceUpdateOnStart)
        {
            chkNoSkillTrining.Checked = NotifyWhenNoSkill;
            chkFinishedTraining.Checked = NotifyWhenFinishedSkill;
            chk5minsleft.Checked = NotifyWhenUnder5Mins;
            chk1hourleft.Checked = NotifyWhenUnder1Hour;
            if (CheckInterval >= numCheckInterval.Minimum && CheckInterval <= numCheckInterval.Maximum)
                numCheckInterval.Value = CheckInterval;
            else
                CheckInterval = 1;
            chkShowStateOnClick.Checked = ShowStatusOnTrayClick;
            chkStartWithWIn.Checked = StartWithWindows;
            chkUpdateOnStart.Checked = ForceUpdateOnStart;
            txtUserID.Text = EveUserID;
            txtApiKey.Text = EveApiKey;
            
        }
        private void SaveSettings()
        {
            skNotify.SaveSettings(
            txtUserID.Text, txtApiKey.Text, chkNoSkillTrining.Checked,
            chkFinishedTraining.Checked, chk5minsleft.Checked,
            chk1hourleft.Checked, (int)numCheckInterval.Value, chkShowStateOnClick.Checked,
            chkStartWithWIn.Checked, chkUpdateOnStart.Checked);
        }

        public void UpdateCacheTime(DateTime cachedUntil)
        {
            lblCachedUntil.Text = "Current Data Cached Until: " + cachedUntil.ToString("h:mm tt");
        }
        public void UpdateSkillInfo(string SkillInfo)
        {
            txtSkillInfo.Text = SkillInfo;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (e.CloseReason == CloseReason.UserClosing)
            {
                e.Cancel = true;
                Hide();
            }
            else
                SaveSettings();
        }
        private void lnkGetKey_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("http://myeve.eve-online.com/api/default.asp");
        }

        private void btnHide_Click(object sender, EventArgs e)
        {
            Hide();
        }

        private void btnSaveApi_Click(object sender, EventArgs e)
        {
            SaveSettings();
            MessageBox.Show(this, "Api Key Saved", "Saved", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void btnSaveSettings_Click(object sender, EventArgs e)
        {
            SaveSettings();
            MessageBox.Show(this, "Settings Saved", "Saved", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            SaveSettings();
            skNotify.Exit();
        }

        private void btnUpdateNow_Click(object sender, EventArgs e)
        {
            string oldtext = btnUpdateNow.Text;
            btnUpdateNow.Text = "Updating...";
            this.Update();
            bool result = skNotify.ForceUpdate();
            btnUpdateNow.Text = oldtext;
        }

        private void btnShowSkillInfo_Click(object sender, EventArgs e)
        {
            skNotify.ShowSkillInfo();
        }

    }
}